--- xyzspain
--- adaptation scripts  for ebro 6115
---manuel leithner  and others
---JD4450FrontLoader 
--- 6820 ls08 @author  Acid_Burn84


ebro = {};

function ebro.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function ebro:load(xmlFile)


---flashlights
	self.FlashLightLeft = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.indexl#index"));
    self.FlashLightRight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.indexr#index"));	  
	self.lightswarnings = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extra_lights.warnings#index"));
    self.flashLightLeftActive = false;
    self.flashLightRightActive = false;
    self.flash = false;
    self.flashRight = false;
    self.flashLeft = false;
    self.delayOnLeft = 0;
    self.delayOffLeft = 0;
    self.delayOnRight = 0;
    self.delayOffRight = 0;
    self.delayOn = 0;
    self.delayOff = 0;
	 turnSoundFile = Utils.getFilename("turn.wav", self.baseDirectory);
    self.turnSoundId = createSample("turnSound");
    loadSample(self.turnSoundId, turnSoundFile, false);
	----  lights dashboard flash
	self.lightDashboardRight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lightdashboardright#index"));
	self.lightDashboardLeft = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lightdashboardleft#index"));
	  setVisibility(self.lightDashboardRight, false);
	  setVisibility(self.lightDashboardLeft, false);
	---------------
	---actuador intermitentes
	self.actuatorflashlights = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.actuatorflashlights#index"));
	--lights
		self.setLightState = SpecializationUtil.callSpecializationsFunction("setLightState");
		local numLights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.lightSources#count"), 0);
    self.lightsSource = {};
    for i=1, numLights do
        local lightnamei = string.format("vehicle.lightSources.source%d", i);
        self.lightsSource[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, lightnamei .. "#index"));
        setVisibility(self.lightsSource[i], false);
    end;
	self.currentLight = 0;
	
	--- worklights 
	self.worklight1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extra_lights.worklight1#index"));
	self.worklight2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extra_lights.worklight2#index"));
	self.worklight3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extra_lights.worklight3#index"));
	self.worklight4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extra_lights.worklight4#index"));
	setVisibility(self.worklight1, false);
	setVisibility(self.worklight2, false);
	setVisibility(self.worklight3, false);
	setVisibility(self.worklight4, false);
	---dashboard low batery
	self.lightlowbatery = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extra_lights.lightlowbatery#index"));
	setVisibility(self.lightlowbatery, false);
	self.printlowbatery=false;
	------ tapas de las luces de trabajo
	self.coverlight1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.coverlight1#index"));
	self.coverlight2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.coverlight2#index"));
	self.coverlight3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.coverlight3#index"));
	self.coverlight4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.coverlight4#index"));
	---actuador luces
	self.actuatorlights = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.actuatorlights#index"));
	
	---wiper
	
    local wiperAnimRootNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.wiper#rootNode"));
    self.wiperAnimCharSet = 0;
    if wiperAnimRootNode ~= nil and wiperAnimRootNode ~= 0 then
        self.wiperAnimCharSet = getAnimCharacterSet(wiperAnimRootNode);
        if self.wiperAnimCharSet ~= 0 then
            local clip = getAnimClipIndex(self.wiperAnimCharSet, getXMLString(xmlFile, "vehicle.wiper#clip"));
            assignAnimTrackClip(self.wiperAnimCharSet, 0, clip);
            setAnimTrackLoopState(self.wiperAnimCharSet, 0, true);
            local wiperAnimSpeedScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.wiper#speedScale"), 1);
			setAnimTrackSpeedScale(self.wiperAnimCharSet, 0, wiperAnimSpeedScale);
            self.wiperAnimDuration = getAnimClipDuration(self.wiperAnimCharSet, clip);
        end;
    end;
	self.isWiperActive = false;
	self.finishWiper = true;
	-- self.manualWiper= false;
	self.wiper=false
	------
	---strobelight
	
	-- self.setStrobeState = SpecializationUtil.callSpecializationsFunction("setStrobeState");
	self.rundumleuchten = {};
    self.rundumleuchten.rotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rundumleuchten#rotNode"));
    self.rundumleuchten.light = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rundumleuchten#light"));
	self.strobelight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.strobelight#index"));
    self.rundumleuchten.source = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rundumleuchten#lightsource"));
    self.rundumleuchten.speed = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.rundumleuchten#rotSpeed"), 1)/1000;
	self.rundumleuchtenAn = false;
	setVisibility(self.strobelight, false);
	
	----
	-- ventilador
	 self.fan = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fan#index"));
    self.fanRotation = 0;
   --- tapa escape
   self.incrementRotation = true;
    self.exhaustCover = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.exhaustCover#index"));
    if self.exhaustCover ~= nil then
        self.exhaustRotationSpeed = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.exhaustCover#rotationSpeed"), 0);
	  self.exhaustRotationMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.exhaustCover#rotationMax"), 0);
	  self.exhaustRotationMin = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.exhaustCover#rotationMin"), 0);
	  self.currentRotation = self.exhaustRotationMin;
    end;
	
	---aguja rpm
	self.increment1Rotation = true;
    self.gaugeRpm = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.gaugeRpm#index"));
    if self.gaugeRpm ~= nil then
        self.gaugeRotationSpeed = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.gaugeRpm#rotationSpeed"), 0);
	  self.gaugeRotationMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.gaugeRpm#rotationMax"), 0);
	  self.gaugeRotationMin = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.gaugeRpm#rotationMin"), 0);
	  self.current1Rotation = self.gaugeRotationMin;
    end;
	----gas pedal
	
    self.gaspedal = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.gaspedal#index"));
   
	---particulas escape 
	self.exhaustParticleSystems = {}; --ps1
    local exhaustParticleSystemCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.exhaustParticleSystems#count"), 0);
    for i=1, exhaustParticleSystemCount do
        local namei = string.format("vehicle.exhaustParticleSystems.part%d", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
        Utils.loadParticleSystem(xmlFile, self.exhaustParticleSystems, namei, nodei, false, nil, self.baseDirectory)			
    end;
	self.exhaustParticleHighSystems = {};---ps1
    local exhaustParticleHighSystemCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.exhaustParticleHighSystems#count"), 0);
    for i=1, exhaustParticleHighSystemCount do
        local namei = string.format("vehicle.exhaustParticleHighSystems.part%d", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
        Utils.loadParticleSystem(xmlFile, self.exhaustParticleHighSystems, namei, nodei, false, nil, self.baseDirectory)			
    end;
	self.exhaustParticleOilSystems = {};
    local exhaustParticleOilSystemCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.exhaustParticleOilSystems#count"), 0);
    for i=1, exhaustParticleOilSystemCount do
        local namei = string.format("vehicle.exhaustParticleOilSystems.part%d", i);
		local nodei = Utils.indexToObject(self.components, getXMLString(xmlFile, namei .. "#index"));
        Utils.loadParticleSystem(xmlFile, self.exhaustParticleOilSystems, namei, nodei, false, nil, self.baseDirectory)			
    end;

	
	--------------
	  self.keys = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
        end;
        self.keys[inputName] = Input[inputKey];
        i = i+1;
    end;
	----------------------
	
	------brake and hanbrake sound and light rotation
	local rotationPartNodeBrake = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPartBrake#index"));
    if rotationPartNodeBrake ~= nil then
        self.rotationPartBrake = {};
        self.rotationPartBrake.node = rotationPartNodeBrake;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartBrake#minRot"));
        self.rotationPartBrake.minRot = {};
        self.rotationPartBrake.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartBrake.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartBrake.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartBrake#maxRot"));
        self.rotationPartBrake.maxRot = {};
        self.rotationPartBrake.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartBrake.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartBrake.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartBrake.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartBrake#rotTime"), 2)*1000;
        self.rotationPartBrake.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartBrake#touchRotLimit"), 10));
    end;
	

	
	
	local brakeSound = getXMLString(xmlFile, "vehicle.brakeSound#file");
    if brakeSound ~= nil and brakeSound ~= "" then
	brakeSound = Utils.getFilename(brakeSound, self.baseDirectory);
        self.brakeSound = createSample("brakeSound");
        loadSample(self.brakeSound, brakeSound, false);
    end;
	
	local handbrakeSound = getXMLString(xmlFile, "vehicle.handbrakeSound#file");
    if handbrakeSound ~= nil and handbrakeSound ~= "" then
	handbrakeSound = Utils.getFilename(handbrakeSound, self.baseDirectory);
        self.handbrakeSound = createSample("handbrakeSound");
        loadSample(self.handbrakeSound, handbrakeSound, false);
    end;
	
		
	self.lightsbrake = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extra_lights.brake#index"));
	self.lightsbrake1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extra_lights.brake1#index"));
	self.lightshandbrake = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extra_lights.handbrake#index"));
	self.handbrakeSoundRunning = false;
    self.brakeForce = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.brakeForce"), 10);
    self.motorBrakeForce = self.motor.brakeForce;
	self.braking = false;
	
	--------
	 self.steeringEnabled = true; 
	 -----marcha atras
	  local reverseDriveSound = getXMLString(xmlFile, "vehicle.reverseDriveSound#file");
    if reverseDriveSound ~= nil and reverseDriveSound ~= "" then
		reverseDriveSound = Utils.getFilename(reverseDriveSound, self.baseDirectory);
        self.reverseDriveSound = createSample("reverseDriveSound");
        self.reverseDriveSoundEnabled = false;
        loadSample(self.reverseDriveSound, reverseDriveSound, false);
    end;
		---luz marcha atras
	self.backlights = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backlights#index"));	
	-------------------------- tanque combustible----------------------------
	--- aguja nivel tanque ,aguja iluminada gestion tanque colores simbolo
	local rotationPartNodeTanknadel = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPartTanknadel#index"));
    if rotationPartNodeTanknadel ~= nil then
        self.rotationPartTanknadel = {};
        self.rotationPartTanknadel.node = rotationPartNodeTanknadel;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#minRot"));
        self.rotationPartTanknadel.minRot = {};
        self.rotationPartTanknadel.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTanknadel.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTanknadel.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#maxRot"));
        self.rotationPartTanknadel.maxRot = {};
        self.rotationPartTanknadel.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTanknadel.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTanknadel.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartTanknadel.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#rotTime"), 2)*1000;
        self.rotationPartTanknadel.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#touchRotLimit"), 10));
    end;
	self.gaugelevelfuel = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extra_lights.gaugelevelfuel#index"));
	setVisibility(self.gaugelevelfuel, false);
	
	
	self.gaugeslevelson = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extra_lights.gaugeslevelson#index"));
	setVisibility(self.gaugeslevelson, false);
	self.fuelCapacity = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fuelCapacity"), 500);
	self.fuelUsage = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fuelUsage"), 0.01);
	-- self:setFuelFillLevel(self.fuelCapacity);

    self.doRefuel = false;
  
    self.fuelWarnlight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.fuelWarnlight#index"));
    setVisibility(self.fuelWarnlight, false);
   

	local fuelWarnSound = getXMLString(xmlFile, "vehicle.fuelWarnSound#file");
    if fuelWarnSound ~= nil and fuelWarnSound ~= "" then
	fuelWarnSound = Utils.getFilename(fuelWarnSound, self.baseDirectory);
        self.fuelWarnSound = createSample("fuelWarnSound");
		loadSample(self.fuelWarnSound, fuelWarnSound, false);
    end;
	local refuelSound = getXMLString(xmlFile, "vehicle.refuelSound#file");
    if refuelSound ~= nil and refuelSound ~= "" then
	refuelSound = Utils.getFilename(refuelSound, self.baseDirectory);
        self.refuelSound = createSample("refuelSound");
		loadSample(self.refuelSound, refuelSound, false);
    end;
	
	self.fuelWarnlightActive = false;
	self.fuelWarnSoundRunning = false;
	self.refuelSoundRunning = false;
	
	----simbolos
	self.greensymbolfuel = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extra_lights.greensymbolfuel#index"));
	self.orangesymbolfuel = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extra_lights.orangesymbolfuel#index"));
	

	
	-------------------------- temperatura nivel----------------------------
	--- aguja nivel temperatura ,aguja iluminada
	local rotationPartNodeLeveltemp = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPartLeveltemp#index"));
    if rotationPartNodeLeveltemp ~= nil then
        self.rotationPartLeveltemp = {};
        self.rotationPartLeveltemp.node = rotationPartNodeLeveltemp;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartLeveltemp#minRot"));
        self.rotationPartLeveltemp.minRot = {};
        self.rotationPartLeveltemp.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartLeveltemp.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartLeveltemp.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartLeveltemp#maxRot"));
        self.rotationPartLeveltemp.maxRot = {};
        self.rotationPartLeveltemp.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartLeveltemp.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartLeveltemp.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartLeveltemp.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartLeveltemp#rotTime"), 2)*1000;
        self.rotationPartLeveltemp.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartLeveltemp#touchRotLimit"), 10));
    end;
	self.gaugeleveltemp = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extra_lights.gaugeleveltemp#index"));
	setVisibility(self.gaugeleveltemp, false);
	
	self.overlow = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.extra_lights.overlow#index"));
	setVisibility(self.overlow, false);
	
	-----------------------------------------------------------------------------------------------------------------------------2 etapa attach shaft and attach implements-------------------------------------------------------
	-- Defines attributes of backHydraulic
	self.backHydraulic = {};
	self.backHydraulic.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backHydraulic#hydraulic"));
	self.backHydraulic.punch = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backHydraulic#hydraulicPunch"));
	self.backHydraulic.translationPunch = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backHydraulic#hydraulicPunchFixPoint"));
	self.backHydraulic.rootArmFixPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backHydraulic#rootArmFixPoint"));
	self.backHydraulic.rootArm = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backHydraulic#rootArm"));
	self.backHydraulic.rootArmPart = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backHydraulic#rootArmPart"));
	self.backHydraulic.armFixPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backHydraulic#armFixPoint"));
	self.backHydraulic.rootArmPartFixPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backHydraulic#rootArmPartFixPoint"));
	local ax, ay, az = getWorldTranslation(self.backHydraulic.punch);
    local bx, by, bz = getWorldTranslation(self.backHydraulic.translationPunch);
    self.backHydraulic.punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
	ax, ay, az = getWorldTranslation(self.backHydraulic.rootArmPart);
    bx, by, bz = getWorldTranslation(self.backHydraulic.rootArmPartFixPoint);
    self.backHydraulic.rootArmDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);

	---defines atributes back attacher
	self.backAttacherJoint = {};
	self.backAttacherJoint.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.trailerAttacherJoints#back"));
	self.backAttacherJoint.upYPos = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.trailerAttacherJoints#upY"), 0);
	self.backAttacherJoint.downYPos = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.trailerAttacherJoints#downY"), 0);	
	local x,y,z = getTranslation(self.backAttacherJoint.node);
	self.backAttacherJoint.xPos = x;
	self.backAttacherJoint.zPos = z;	
	setTranslation(self.backAttacherJoint.node, self.backAttacherJoint.xPos, self.backAttacherJoint.upYPos, self.backAttacherJoint.zPos);
	self.moveDownIntervall = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.moveDownIntervall#ms"), 1000);
	self.updateJoint = false;
	self.doLowering = false;
	self.loweringDone = false;
	self.nextAction = false;
	self.delay = 0;
	-------
	self.lastSpeed=0;
end;

function ebro:delete()
-- Utils.deleteParticleSystem(self.exhaustParticleSystems, false)
-- Utils.deleteParticleSystem(self.exhaustParticleHighSystems, false)
-- Utils.deleteParticleSystem(self.exhaustParticleOilSystems, false)

	
 if self.reverseDriveSoundEnabled then
        stopSample(self.reverseDriveSound);
        self.reverseDriveSoundEnabled = false;
    end;
   
end;
function ebro:mouseEvent(posX, posY, isDown, isUp, button)
end;
function ebro:keyEvent(unicode, sym, modifier, isDown)

--flashlights--
	
		if isDown and sym == Input.KEY_KP_1 then
		self.flashLeft = not self.flashLeft;
		self.delayOnLeft = 10;
		self.flashRight = false;
		self.flash = false;
		self.flashLightRightActive = false;
	end;

	if isDown and sym == Input.KEY_KP_3 then
		self.flashRight = not self.flashRight;
		self.delayOnRight = 10;
		self.flashLeft = false;
		self.flash = false;
		self.flashLightLeftActive = false;
	end;
	if isDown and sym == Input.KEY_KP_2 then
		self.flash = not self.flash;
		self.flashRight = false;
		self.flashLeft = false;
		self.delayOn = 20;
		self.flashLightRightActive = false;
		self.flashLightLeftActive = false;
	end;
	
	if isDown and sym == Input.KEY_S then
		self.reverse = true;
		else
		self.reverse = false;
	end;
	if getInputAxis(Input.AXIS_Y) == -1 then
		self.reverse = true;
		else
		self.reverse = false;
	end;
	
	if self:getIsActiveForInput() and InputBinding.isPressed(InputBinding.STROBELIGHT)  then
        self.rundumleuchtenAn = not self.rundumleuchtenAn;
        setVisibility(self.rundumleuchten.light, self.rundumleuchtenAn);
		
    end;
	
	--wiper manual test

	-- if isDown and sym == Input.KEY_x then
	-- self.manualWiper= not self.manualWiper;
	-- end;
	if self:getIsActiveForInput() and InputBinding.isPressed(InputBinding.MF_IGNITION)  then
        self.wiper = not self.wiper;
      end;
	
	--handbrake
			if isDown and sym == Input.KEY_space then
		self.handbrake = not self.handbrake;
	end;

------------2 etapa------------------
if sym == 308  and isDown then
		if table.getn(self.attachedImplements) == 1 then			
			self.loweringDone = false;
			self.delay = self.moveDownIntervall;
			self.doLowering = true;
			self.nextAction = not self.attacherJoints[1].moveDown;
			-- if self.attacherJoints[2].moveDown ~= not self.nextAction then 
				-- self.nextAction = false;
			-- end;
		end;
	end;
	
end;
function ebro:update(dt)	


--- flashLights
if self:getIsActive() then --aislarlo de otros objetos
	if self.FlashLightLeft ~= nil then
            if self.flashLightLeftActive then
            	setVisibility(self.FlashLightLeft, self.flashLightLeftActive);
				
	    else
            	setVisibility(self.FlashLightLeft, self.flashLightLeftActive);
	    end;
        end;

	if self.FlashLightRight ~= nil then
            if self.FlashLightRightActive then
            	setVisibility(self.FlashLightRight, self.flashLightRightActive);
	    else
            	setVisibility(self.FlashLightRight, self.flashLightRightActive);
	    end;
        end;

	if self.flashLeft then
		if self.delayOnLeft >= -1 then
			self.delayOnLeft = self.delayOnLeft -dt;
		end;
		if not self.flashLightLeftActive then
			if self.delayOnLeft < 0 then
				self.delayOffLeft = 500;
				self.flashLightLeftActive = true;
				playSample(self.turnSoundId, 1, 0.7, 0);
			end;
		end;
		if self.delayOffLeft >= 0 then
			self.delayOffLeft = self.delayOffLeft -dt;
		end;
		if self.flashLightLeftActive then
			if self.delayOffLeft < 0 then
				self.delayOnLeft = 500;
				self.flashLightLeftActive = false;
			end;
		end;
	end;

	if self.flashRight then
		if self.delayOnRight >= 0 then
			self.delayOnRight = self.delayOnRight -dt;
		end;
		if not self.flashLightRightActive then
			if self.delayOnRight < 0 then
				self.delayOffRight = 500;
				self.flashLightRightActive = true;
				playSample(self.turnSoundId, 1, 0.7, 0);
			end;
		end;
		if self.delayOffRight >= 0 then
			self.delayOffRight = self.delayOffRight -dt;
		end;
		if self.flashLightRightActive then
			if self.delayOffRight < 0 then
				self.delayOnRight = 500;
				self.flashLightRightActive = false;
			end;
		end;
	end;

	if self.flash then
	
		if self.delayOn >= 0 then
			self.delayOn = self.delayOn -dt;
		end;
		if not self.flashLightRightActive then
			if self.delayOn < 0 then
				self.delayOff = 500;
				setVisibility(self.lightswarnings, true); ---piloto
				self.flashLightRightActive = true;
				self.flashLightLeftActive = true;
				playSample(self.turnSoundId, 1, 0.7, 0);
				
			end;
		end;
		if self.delayOff >= 0 then
			self.delayOff = self.delayOff -dt;
		end;
		if self.flashLightRightActive then
			if self.delayOff < 0 then
				self.delayOn = 500;
				setVisibility(self.lightswarnings, false); ---piloto
				self.flashLightLeftActive = false;
				self.flashLightRightActive = false;
			end;
		end;
		else
		setVisibility(self.lightswarnings, false); ---piloto
	end;

	if not self.flashLeft and not self.flashRight then
		if not self.flash then
			self.flashLightRightActive = false;
			self.flashLightLeftActive = false;
		end;
	end;
		
	if not self.flash and not self.flashLeft then
		if not self.flashRight then
			self.flashLightRightActive = false;
		end;
	end;

	if not self.flash and not self.flashRight then
		if not self.flashLeft then
			self.flashLightLeftActive = false;
		end;
	end;
end;
----- mando intermitentes
if self.flashLightLeftActive == false and self.flashRight then
  setRotation(self.actuatorflashlights, 0, Utils.degToRad(-20), 0);
elseif self.flashLightLeftActive == false and not  self.flashRight then
setRotation(self.actuatorflashlights, 0, Utils.degToRad(0), 0);
end;

if self.flashLightRightActive == false and self.flashLeft then
  setRotation(self.actuatorflashlights, 0, Utils.degToRad(20), 0);
elseif self.flashLightRighttActive == false and not  self.flashLeft then
setRotation(self.actuatorflashlights, 0, Utils.degToRad(0), 0);
end;
---- dashboard flashlights
 if self.flashLightLeftActive ==true then
	 setVisibility(self.lightDashboardLeft, true);
	 else
	 setVisibility(self.lightDashboardLeft, false);
end;
if self.flashLightRightActive ==true then
	 setVisibility(self.lightDashboardRight, true);
	 else
	 setVisibility(self.lightDashboardRight, false);
end;
--lights
	if self:getIsActiveForInput() then
		-- Modulo division to get a controlled switch between each lights
        if InputBinding.hasEvent(InputBinding.TOGGLE_LIGHTS) then
			self:setLightState((self.currentLight + 1) % (table.getn(self.lightsSource) + 1));
			
        end;
	end;
	
	
		
	------ tapas cubre luces y worklights
if self.currentLight  == 2  then
		setVisibility(self.worklight1, true);
		setVisibility(self.worklight2, true);
		setVisibility(self.worklight3, true);
		setVisibility(self.worklight4, true);
		setVisibility(self.coverlight1, false);
		setVisibility(self.coverlight2, false);
		setVisibility(self.coverlight3, false);	
		setVisibility(self.coverlight4, false);
	elseif self.currentLight ~=2 then
		setVisibility(self.coverlight1, true);
		setVisibility(self.coverlight2, true);
		setVisibility(self.coverlight3, true);			
		setVisibility(self.coverlight4, true);
		setVisibility(self.worklight1, false);
		setVisibility(self.worklight2, false);
		setVisibility(self.worklight3, false);
		setVisibility(self.worklight4, false);
 end;
 	
 --- mando multifuncion luces
	 if self.currentLight ==1 then
		   setRotation(self.actuatorlights,Utils.degToRad(90), 0, 0);
	elseif self.currentLight ~=1 then 
			setRotation(self.actuatorlights,Utils.degToRad(0), 0, 0);
			
	end;
	--- activar luces en dashboard 
	if self.currentLight ==0 then
	setVisibility(self.gaugelevelfuel, false);--aguja
	setVisibility(self.gaugeslevelson, false);-- fondo
	elseif self.currentLight ~=0 then
	setVisibility(self.gaugelevelfuel, true);
	setVisibility(self.gaugeslevelson, true);
	end;
	
	---wiper
	
	if self:getIsActive()  then
	-- if not self.finishWiper  then
			-- if getAnimTrackTime(self.wiperAnimCharSet, 0) % self.wiperAnimDuration <= 100 then
				-- setAnimTrackTime(self.wiperAnimCharSet, 0, 0.0);
				-- disableAnimTrack(self.wiperAnimCharSet, 0);			
				-- self.finishWiper = true;
			-- end;			
		-- end;
	if self.wiper then	
		if g_currentMission.environment.lastRainScale > 0.1 and g_currentMission.environment.timeSinceLastRain < 30 or self.manualWiper  then
			if not self.isWiperActive  then
				enableAnimTrack(self.wiperAnimCharSet, 0);
				self.isWiperActive = true;
			end;
		else
			if self.isWiperActive  then
				self.isWiperActive = false;
				self.finishWiper = false;
			end;
		end;
		else
		self.isWiperActive = false;
		self.finishWiper = false;
		if not self.finishWiper  then
			if getAnimTrackTime(self.wiperAnimCharSet, 0) % self.wiperAnimDuration <= 100 then
				setAnimTrackTime(self.wiperAnimCharSet, 0, 0.0);
				disableAnimTrack(self.wiperAnimCharSet, 0);			
				self.finishWiper = true;
			end;			
		end;
		end;
end;

-------------
---strobelight


if self:getIsActive() then
	if self.rundumleuchtenAn  then
		rotate(self.rundumleuchten.rotNode, 0, dt*self.rundumleuchten.speed, 0);
		setVisibility(self.strobelight, true);
		setVisibility(self.rundumleuchten.light, self.rundumleuchtenAn);
	elseif not self.rundumleuchtenAn or  self.ignitionKey == false then 
		setVisibility(self.strobelight, false);--piloto
		setVisibility(self.rundumleuchten.light, false);
		end;
end;
---dependen de encendido externo de otra especializacion 

---ventilador
if  self.ignitionKey == true then
if self.isHired or self.isEntered then
		self.fanRotation = self.fanRotation + 30 + math.max(self.motor.lastMotorRpm/50,0);
		setRotation(self.fan, 0, 0, Utils.degToRad(self.fanRotation));
---tapa escape
		local rpm = math.max(self.motor.lastMotorRpm/50,0);
		local rpmDeltaMotion = math.max(self.motor.lastMotorRpm/300,0);
             
	      if self.incrementRotation == true then 
        		self.currentRotation = self.currentRotation + self.exhaustRotationSpeed;
	 	else
			self.currentRotation = self.currentRotation - self.exhaustRotationSpeed;
	 	end;

	  	if self.currentRotation >= (self.exhaustRotationMax - rpmDeltaMotion)then
			self.incrementRotation = false;
	 	elseif self.currentRotation <= (self.exhaustRotationMin + rpmDeltaMotion) then
  			self.incrementRotation = true;
	  	end;
	      setRotation(self.exhaustCover,Utils.degToRad(self.currentRotation+rpm), 0, 0);
	else 
		setRotation(self.exhaustCover, 0, Utils.degToRad(0), 0);
	end;
	else
	setRotation(self.exhaustCover, 0, Utils.degToRad(0), 0); 
	end;
	-----aguja rpm
	
	 
if self.isHired or self.isEntered then
	
		local rpm = math.max(self.motor.lastMotorRpm/10,0);
		local rpmDeltaMotion = math.max(self.motor.lastMotorRpm/300,0);
             
	      if self.increment1Rotation == true then 
        		self.current1Rotation = self.current1Rotation + self.gaugeRotationSpeed;
	 	else
			self.current1Rotation = self.current1Rotation - self.gaugeRotationSpeed;
	 	end;

	  	if self.current1Rotation >= (self.gaugeRotationMax - rpmDeltaMotion)then
			self.increment1Rotation = false;
	 	elseif self.current1Rotation <= (self.gaugeRotationMin + rpmDeltaMotion) then
  			self.increment1Rotation = true;
	  	end;
		if  self.ignitionKey == true then
	      setRotation(self.gaugeRpm,0,-(Utils.degToRad(self.current1Rotation+rpm)), 0);
		  else
		  setRotation(self.gaugeRpm, 0, Utils.degToRad(0), 0);
		end;
	else 
		setRotation(self.gaugeRpm, 0, Utils.degToRad(0), 0);
end;

---- gaspedal a lo facil 
if  self.ignitionKey == true then
if self.isMotorStarted then
		if self.motor.lastMotorRpm > 200 and self.motor.lastMotorRpm < 400 then
		setRotation(self.gaspedal,Utils.degToRad(-45),0, 0);
		elseif self.motor.lastMotorRpm > 350 and self.motor.lastMotorRpm < 500 then
		setRotation(self.gaspedal,Utils.degToRad(-42),0, 0);
		end;
		if self.motor.lastMotorRpm > 450 and self.motor.lastMotorRpm < 600 then
		setRotation(self.gaspedal,Utils.degToRad(-40),0, 0);
		elseif self.motor.lastMotorRpm > 550 and self.motor.lastMotorRpm < 700 then
		setRotation(self.gaspedal,Utils.degToRad(-37),0, 0);
		end;
		if self.motor.lastMotorRpm > 650 and self.motor.lastMotorRpm < 800 then
		setRotation(self.gaspedal,Utils.degToRad(-35),0, 0);
		elseif self.motor.lastMotorRpm > 750 and self.motor.lastMotorRpm < 900 then
		setRotation(self.gaspedal,Utils.degToRad(-32),0, 0);
		end;
		if self.motor.lastMotorRpm > 850 and self.motor.lastMotorRpm < 1000 then
		setRotation(self.gaspedal,Utils.degToRad(-30),0, 0);
		elseif self.motor.lastMotorRpm > 950 and self.motor.lastMotorRpm < 1100 then
		setRotation(self.gaspedal,Utils.degToRad(-28),0, 0);
		end;
		if self.motor.lastMotorRpm > 1050 and self.motor.lastMotorRpm < 1200 then
		setRotation(self.gaspedal,Utils.degToRad(-25),0, 0);
		elseif self.motor.lastMotorRpm > 1150 and self.motor.lastMotorRpm < 1300 then
		setRotation(self.gaspedal,Utils.degToRad(-22),0, 0);
		end;
		if self.motor.lastMotorRpm > 1250 and self.motor.lastMotorRpm < 1400 then
		setRotation(self.gaspedal,Utils.degToRad(-19),0, 0);
		elseif self.motor.lastMotorRpm > 1350 and self.motor.lastMotorRpm < 1500 then
		setRotation(self.gaspedal,Utils.degToRad(-16),0, 0);
		end;
		if self.motor.lastMotorRpm > 1450 and self.motor.lastMotorRpm < 1700 then
		setRotation(self.gaspedal,Utils.degToRad(-13),0, 0);
		elseif self.motor.lastMotorRpm > 1650 and self.motor.lastMotorRpm < 1800 then
		setRotation(self.gaspedal,Utils.degToRad(-10),0, 0);
		end;
		if self.handbrake then
		setRotation(self.gaspedal,Utils.degToRad(-45),0, 0); 
		end;
		end;
end;
------particulas extra
if  self.ignitionKey == true then
  if self.isMotorStarted then
	Utils.setEmittingState(self.exhaustParticleOilSystems, true)
		if self.motor.lastMotorRpm > 50 and self.motor.lastMotorRpm < 1399 then
			Utils.setEmittingState(self.exhaustParticleSystems, true)
			Utils.setEmittingState(self.exhaustParticleHighSystems, false)
		elseif self.motor.lastMotorRpm > 1400  then
				Utils.setEmittingState(self.exhaustParticleSystems, true)
        	Utils.setEmittingState(self.exhaustParticleHighSystems, true)
		end;
		else 
      	Utils.setEmittingState(self.exhaustParticleSystems, false);
      Utils.setEmittingState(self.exhaustParticleHighSystems, false)
	  Utils.setEmittingState(self.exhaustParticleOilSystems, false)
		  end;
	else 
	Utils.setEmittingState(self.exhaustParticleSystems, false)
     Utils.setEmittingState(self.exhaustParticleHighSystems, false)
	 Utils.setEmittingState(self.exhaustParticleOilSystems, false)
	end;
	------------------------------------
	  inputAxisY = InputBinding.getAnalogInputAxis(InputBinding.AXIS_FORWARD);

        if InputBinding.isAxisZero(inputAxisY) then
        inputAxisY = InputBinding.getDigitalInputAxis(InputBinding.AXIS_FORWARD);
        end;
		-------------------------------------------
	---- overlow
if  self.ignitionKey == true then
		if self.isMotorStarted then
			if self.motor.lastMotorRpm > 2000 and self.speedLevel==3 then
				if self.vehicle.lastSpeed*3600 < 18 then
				setVisibility(self.overlow, true);
				else
				setVisibility(self.overlow, false);
				end;
			end;
		end;
end;	
		
		
		
----brake and handbrake

if self.isEntered then
		if (self.movingDirection*self.lastSpeed*(-inputAxisY)) < -0.001 then
			setVisibility(self.lightsbrake, true);
			setVisibility(self.lightsbrake1, true);
			self.motor.brakeForce = self.motorBrakeForce;
				if not self.brakeSoundRunning then
					playSample(self.brakeSound, 1, 1, 0);
					self.brakeSoundRunning = true;
					
				end;
			self.braking = true;
			
		else
			if not self.handbrake then
				self.motor.brakeForce = self.motor.brakeForce*0;
			end;
		     setVisibility(self.lightsbrake, false);
			 setVisibility(self.lightsbrake1, false);
			self.braking = false;
			self.brakeSoundRunning = false;	
		
		end;
	--- rotation brake pedals
	if self.braking  then
	self.rotationMaxBrake=true;
	else
	self.rotationMaxBrake=false;
	end;
	if self.rotationPartBrake ~= nil then
		local x, y, z = getRotation(self.rotationPartBrake.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartBrake.maxRot, self.rotationPartBrake.minRot, 3, self.rotationPartBrake.rotTime, dt, not self.rotationMaxBrake);
		setRotation(self.rotationPartBrake.node, unpack(newRot));
	end;
	
     if g_currentMission.attachableInMountRange ~= nil then
                self.motor.brakeForce = self.brakeForce;
      end;
			
		if self.handbrake then
			brakeTorque = 20000;
		self.motor.brakeForce = brakeTorque;
		    self.braking = true;
		setVisibility(self.lightshandbrake, self.handbrake);
			if not self.handbrakeSoundRunning then
				playSample(self.handbrakeSound, 1, 1, 0);
				self.handbrakeSoundRunning = true;
			end;
		else

		setVisibility(self.lightshandbrake, false);
			self.handbrakeSoundRunning = false;
		end;
	
 end;

	---end brake an handbrake
	
---marcha atras
if  self.ignitionKey == true then
      if self.reverseDriveSound ~= nil and self.movingDirection == -1  then
            if not self.reverseDriveSoundEnabled then
                playSample(self.reverseDriveSound, 0, 0.7, 0);
                self.reverseDriveSoundEnabled = true;
				
            end;
     
           elseif self.reverseDriveSoundEnabled then
                stopSample(self.reverseDriveSound);
                self.reverseDriveSoundEnabled = false;
				
           end;
       

				--backlights

			if self.movingDirection == -1 then
			setVisibility(self.backlights, true);
			elseif self.movingDirection ~=-1  then 
			setVisibility(self.backlights, false);
			
				end;
	else
	setVisibility(self.backlights, false);
	 self.reverseDriveSoundEnabled = false;
end;
	---- tanque combustible--------------------------------------------------------------------------------------------------
	--rotacion aguja nivel tanque
if self.rotationPartTanknadel ~= nil and self.ignitionKey == true then 
			local x, y, z = getRotation(self.rotationPartTanknadel.node);
			y = ((self.rotationPartTanknadel.maxRot[2] - self.rotationPartTanknadel.minRot[2]) / self.fuelCapacity) * self.fuelFillLevel + self.rotationPartTanknadel.minRot[2];
			setRotation(self.rotationPartTanknadel.node, x, y ,z);
			elseif self.ignitionKey == false then
			local x, y, z = getRotation(self.rotationPartTanknadel.node);
			y =  self.rotationPartTanknadel.minRot[2];
			setRotation(self.rotationPartTanknadel.node, x, y ,z);
		end;
	----simbolos	
if 	self.ignitionKey == true and self.fuelWarner == false then
	local x, y, z = getRotation(self.rotationPartTanknadel.node);
	if y > Utils.degToRad(51) then
			setVisibility(self.greensymbolfuel, true);
			setVisibility(self.orangesymbolfuel, false);		
		elseif  y < Utils.degToRad(51)  then
			setVisibility(self.greensymbolfuel, false);
			setVisibility(self.orangesymbolfuel, true);
		end;
	
	
elseif self.ignitionKey == false or self.fuelWarner == true  then
	setVisibility(self.greensymbolfuel, false);
	setVisibility(self.orangesymbolfuel, false);		
		
end;	
---------------------recarga calculo y grabar no funciona   
  local fuelUsed = (self.motor.lastMotorRpm/1000)*self.fuelUsage;
        self:setFuelFillLevel(self.fuelFillLevel-fuelUsed);

        g_currentMission.missionStats.fuelUsageTotal = g_currentMission.missionStats.fuelUsageTotal + fuelUsed;
        g_currentMission.missionStats.fuelUsageSession = g_currentMission.missionStats.fuelUsageSession + fuelUsed;
        
        g_currentMission.missionStats.traveledDistanceTotal = g_currentMission.missionStats.traveledDistanceTotal + self.lastMovedDistance*0.001;
        g_currentMission.missionStats.traveledDistanceSession = g_currentMission.missionStats.traveledDistanceSession + self.lastMovedDistance*0.001;
	
		if self.hasRefuelStationInRange and InputBinding.hasEvent(InputBinding.REFUEL) then
		self.doRefuel = true;
		end;

	 if self.fuelFillLevel == 0 then
		acceleration = 0;
	 end;
	 self.doRefuel = self.doRefuel and self.hasRefuelStationInRange;
        if self.doRefuel then
        
            if not self.refuelSoundRunning then
               --- print("start");
                playSample(self.refuelSound, 0, 1, 0);
                self.refuelSoundRunning = true;
            end;
        
            local refuelSpeed = 0.01;
            local currentFillLevel = self.fuelFillLevel;
            self:setFuelFillLevel(self.fuelFillLevel+refuelSpeed*dt);
            local delta = (self.fuelFillLevel-currentFillLevel)*g_fuelPricePerLiter;
            
          ---  print("delta ", delta);
            
            if delta <= 0 then
                self.doRefuel = false;
            end;
            
            g_currentMission.missionStats.expensesTotal = g_currentMission.missionStats.expensesTotal + delta;
            g_currentMission.missionStats.expensesSession = g_currentMission.missionStats.expensesSession + delta;
            g_currentMission.missionStats.money = g_currentMission.missionStats.money - delta;

        else
            if self.refuelSoundRunning then
              ----  print("stop");
                stopSample(self.refuelSound);
                self.refuelSoundRunning = false;
            end;
        end;
		-----------
		if self.isEntered then
		if self.fuelWarner then
			if self.delayFuelOn >= 0 then
				self.delayFuelOn = self.delayFuelOn -dt;
			end;
			if not self.fuelWarnlightActive then
				if self.delayFuelOn < 0 then
					self.delayFuelOff = 500;
					self.fuelWarnlightActive = true;
				end;
			end;
			if self.delayFuelOff >= 0 then
				self.delayFuelOff = self.delayFuelOff -dt;
			end;
			if self.fuelWarnlightActive then
				if self.delayFuelOff < 0 then
					self.delayFuelOn = 500;
					self.fuelWarnlightActive = false;
				end;
			end;
			if self.delayFuelSoundOn >= 0 then
				self.delayFuelSoundOn = self.delayFuelSoundOn -dt;
			end;
			if not self.fuelWarnSoundRunning then
				if self.delayFuelSoundOn < 0 then
					self.delayFuelSoundOff = 4000;
					playSample(self.fuelWarnSound, 1, 1, 0);
					self.fuelWarnSoundRunning = true;
					-- setVisibility(self.fuelWarnlight, true);
				end;
			end;
			if self.delayFuelSoundOff >= 0 then
				self.delayFuelSoundOff = self.delayFuelSoundOff -dt;
			end;
			if self.fuelWarnSoundRunning then
				if self.delayFuelSoundOff < 0 then
					self.delayFuelSoundOn = 20000;
					stopSample(self.fuelWarnSound);
					self.fuelWarnSoundRunning = false;
					-- setVisibility(self.fuelWarnlight, false);
				end;
			end;	
		else
			self.fuelWarnlightActive = false;
			self.delayFuelOn = 10;
			self.delayFuelSoundOn = 10;
			stopSample(self.fuelWarnSound);
			self.fuelWarnSoundRunning = false;
		end;
		local fuelWarn = 75;
		if self.fuelFillLevel < fuelWarn then
		setVisibility(self.fuelWarnlight, true);
			self.fuelWarner = true;
		else
			self.fuelWarner = false;
			setVisibility(self.fuelWarnlight, false);
		end;
	end;	
	
		
		
	--rotacion aguja nivel temperatura
if self.rotationPartLeveltemp ~= nil and self.ignitionKey == true then 
			local x, y, z = getRotation(self.rotationPartLeveltemp.node);
			y = self.rotationPartLeveltemp.maxRot[2] ;
			setRotation(self.rotationPartLeveltemp.node, x, y ,z);
			elseif self.ignitionKey == false then
			local x, y, z = getRotation(self.rotationPartLeveltemp.node);
			y =  self.rotationPartLeveltemp.minRot[2];
			setRotation(self.rotationPartLeveltemp.node, x, y ,z);
		end;
		
	
		----------------------------------------------------------
	-------------------------------2 etapa--------------------------
	if self:getIsActive() then
	
		if self.doLowering then	
			local back = self.attacherJoints[1];
			
			if self.loweringDone then
				self.delay = self.delay - dt;				
				if self.delay <= 0 then
					back.moveDown = self.nextAction;
					self.doLowering = false;
				end;
			end;
		end;
	-- oriented all hydraulicparts towards the right place
		if self.backHydraulic ~= nil then
			-- set correct rotation on rootArm
			local x, y, z = getRotation(getParent(getParent(self.backHydraulic.armFixPoint)));
			setRotation(self.backHydraulic.rootArm, x, y, z);	

			-- oriented rootArmPart towards a fixpoint on the bottomArm
			local ax, ay, az = getWorldTranslation(self.backHydraulic.rootArmPart);
			local bx, by, bz = getWorldTranslation(self.backHydraulic.armFixPoint);
			x, y, z = worldDirectionToLocal(getParent(self.backHydraulic.rootArmPart), bx-ax, by-ay, bz-az);
			setDirection(self.backHydraulic.rootArmPart, x, y, z, 0, 0, 1);	
			
			
			-- scale the rootArmPart to get a better looking style 
			if self.backHydraulic.rootArmPart ~= nil then
				local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
				local xScale, yScale, zScale = getScale(self.backHydraulic.rootArmPart);
				local newScale = zScale * (distance / self.backHydraulic.rootArmDistance);
				setScale(self.backHydraulic.rootArmPart, 1, 1, newScale);
			end;		
		
			-- oriented hydraulic towards a fixpoint on the rootArm
			ax, ay, az = getWorldTranslation(self.backHydraulic.node);
			bx, by, bz = getWorldTranslation(self.backHydraulic.rootArmFixPoint);
			x, y, z = worldDirectionToLocal(getParent(self.backHydraulic.node), bx-ax, by-ay, bz-az);
			setDirection(self.backHydraulic.node, x, y, z, 0, 1, 1);
			if self.backHydraulic.punch ~= nil then
				local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
				local x,y,z = getTranslation(self.backHydraulic.punch);
				setTranslation(self.backHydraulic.punch, x, y, (distance-self.backHydraulic.punchDistance));
			end;			
		end;	
	end;

-- juntas
	local joint = self.componentJoints[1];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
	local joint = self.componentJoints[2];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);
	local joint = self.componentJoints[3];
		setJointFrame(joint.jointIndex, 0,joint.jointNode);

end;

function ebro:draw()
if self.handbrake then
		setTextBold(false);
		setTextColor(1,0,0,1);
		-- if (self.movingDirection*self.lastSpeed*(-inputAxisY))  then
			-- setTextBold(true);
			-- setTextColor(1,0,0,1);
			-- renderText(0.3, 0.3, 0.05, "BITTE HANDBREMSE LSEN!");
		-- end;
		renderText(0.875, 0.19, 0.015, "(!) Handbremse Aktiv");	
	end;
if self.printlowbatery then
		setTextBold(true);
		setTextColor(1,0,0,1);
		renderText(0.35, 0.35, 0.05, "LOW BATERY,START MOTOR!");
end;
if self.isEntered then

        self.hudBaseOverlay:render();

        setTextBold(true);
        setTextColor(1.0, 1.0, 1.0, 1.0);
        local fuelWarn = 75;
        if self.fuelFillLevel < fuelWarn then
            setTextColor(1,0,0,1);
        end;
        renderText(self.hudBasePoxX+0.031, self.hudBasePoxY+0.039, 0.03, string.format("%d liter", self.fuelFillLevel));
        if self.fuelFillLevel < fuelWarn then
            setTextColor(1,1,1,1);
        end;
        
        
        setTextBold(false);


        if self.hasRefuelStationInRange and not self.doRefuel and self.fuelFillLevel ~= self.fuelCapacity then
            g_currentMission:addHelpButtonText(g_i18n:getText("Refuel"), InputBinding.REFUEL);
        end;
    end;	
end;


-- state 0: disabled
-- state 1: normal light
-- state 2: working light
function ebro:setLightState(state)
	if self.currentLight == state  then
		state = 0;
	end;
	if state >= 0 and state <= table.getn(self.lightsSource) then
		self:setLightsVisibility(state > 0);		
		if self.currentLight > 0 then
			setVisibility(self.lightsSource[self.currentLight], false);
		end;
		if state > 0 then
			setVisibility(self.lightsSource[state], true);
		end;
		self.currentLight = state;		
	else
		print("Error: given light state not available");
	end;
end;


function ebro:onLeave()
	self.isEntered = false;
  
    if self.reverseDriveSoundEnabled then
        stopSample(self.reverseDriveSound);
        self.reverseDriveSoundEnabled = false;
    end;
    self.doRefuel = false;
----------------------------------- 
    if self.deactivateLightsOnLeave then
        self:setLightState(0);
    end;
	
	if self.isWiperActive then
		disableAnimTrack(self.wiperAnimCharSet, 0);	
	end;
		Utils.setEmittingState(self.exhaustParticleSystems, false)
		Utils.setEmittingState(self.exhaustParticleHighSystems, false)
		Utils.setEmittingState(self.exhaustParticleOilSystems, false)
end;

function ebro:onEnter()
	-- if self.isWiperActive then
		-- enableAnimTrack(self.wiperAnimCharSet, 0);	
	-- end;
	  if self.reverseDriveSoundEnabled then
        stopSample(self.reverseDriveSound);
        self.reverseDriveSoundEnabled = false;
    end;
		Utils.setEmittingState(self.exhaustParticleSystems, false)
		Utils.setEmittingState(self.exhaustParticleHighSystems, false)
		Utils.setEmittingState(self.exhaustParticleOilSystems, false)
end;
function key_convert(key)
    if key ~= nil then 
	    local keyname = "";
	    if key > 32 and key < 123 then
	    	keyname = string.upper(string.char(key));
	    elseif key > 255 and key < 266 then
	    	keyname = "NUM "..string.char(key-208);
	    else 
	    	keyname = "";
	    end;
	    return(keyname);
	  end;
end;
function ebro:attachImplement(implement)
	
	local jointType = implement.object.attacherJoint.jointType;
	local jointIndex = implement.jointDescIndex;
	
	if jointType == Vehicle.JOINTTYPE_IMPLEMENT then	
		-- index 1 defines back hydraulic
		if jointIndex == 1 then
			setVisibility(self.backAttacherJoint.node, false);
		-- elseif jointIndex == 2 then
			-- setVisibility(self.frontAttacherJoint.node, false);
			-- setVisibility(self.attacherJoints[jointIndex].topArm.rotationNode, true);
		end;
	elseif jointType == Vehicle.JOINTTYPE_TRAILER then
		if jointIndex == 3 then
			setVisibility(self.backAttacherJoint.node, true);	
			setTranslation(self.backAttacherJoint.node, self.backAttacherJoint.xPos, self.backAttacherJoint.upYPos, self.backAttacherJoint.zPos);	
		end;
	elseif jointType == Vehicle.JOINTTYPE_TRAILERLOW then
		if jointIndex == 5 then
			setVisibility(self.backAttacherJoint.node, true);	
			setTranslation(self.backAttacherJoint.node, self.backAttacherJoint.xPos, self.backAttacherJoint.downYPos, self.backAttacherJoint.zPos);
		end;
	end;
	self.updateJoint = true;
	
end;

function ebro:detachImplement(implementIndex)

	local implement = self.attachedImplements[implementIndex];
	local jointIndex = implement.jointDescIndex;

	if jointIndex == 1 then
		setVisibility(self.backAttacherJoint.node, true);
	-- elseif jointIndex == 2 then
		-- setVisibility(self.frontAttacherJoint.node, true);
		-- setVisibility(self.attacherJoints[jointIndex].topArm.rotationNode, false);
	elseif jointIndex == 5 then
		setTranslation(self.backAttacherJoint.node, self.backAttacherJoint.xPos, self.backAttacherJoint.upYPos, self.backAttacherJoint.zPos);
	end;
end;

function ebro:validateAttacherJoint(implement, jointDesc, dt)
    if self.updateJoint then
        self.updateJoint = false;
        return true;
    end;
    return false;
end;

function ebro:setFuelFillLevel(newFillLevel)
    self.fuelFillLevel = math.max(math.min(newFillLevel, self.fuelCapacity), 0);
end;

